<template>
	<v-list-item-content v-if="isLoaded && !hasError">
		<router-link :to="`sampling-collection/${samplingCollection.id}`">
			<v-list-item-title v-if="samplingCollection.dateCreated">
				{{ (field && field.name) || 'Unknown Field' }} -
				{{ new Date(samplingCollection.dateCreated).toLocaleString() }}
				<span class="text-caption">(created)</span>
			</v-list-item-title>
		</router-link>
		<v-list-item-subtitle>
			<span class="font-weight-medium">Field:</span> {{ (field && field.name) || 'Unknown Field' }}
		</v-list-item-subtitle>
		<v-list-item-subtitle v-if="samplingCollection.dateModified">
			<span class="font-weight-medium">Last modified:</span>
			{{ new Date(samplingCollection.dateModified).toLocaleString() }}
		</v-list-item-subtitle>
		<v-list-item-subtitle>
			<v-icon small class="mr-1"> mdi-triangle </v-icon>{{ progressText }} locations collected
		</v-list-item-subtitle>
		<v-list-item-subtitle class="d-flex justify-center align-center mt-4 mx-2 pb-2" v-if="!locationCollection">
			<v-icon color="warning">mdi-alert-circle</v-icon>
			<v-divider vertical class="mx-2" />
			<div class="subtitle-2">
				{{ ORPHANED_DRAFT_SAMPLING_COLLECTION_INFO }}
			</div>
		</v-list-item-subtitle>
	</v-list-item-content>
</template>

<script lang="ts">
import { computed, ComputedRef, defineComponent } from '@vue/composition-api';
import { useAllResources } from '@/store/modules/resources';
import { useAllSamplingCollections } from '@/store/modules/samplingCollections';
import { useAllSamplings } from '@/store/modules/samplings';
import { Field, LocationCollection, Sampling, SamplingCollection, SamplingCollectionStatus } from '@/store/types';
import { ORPHANED_DRAFT_SAMPLING_COLLECTION_INFO } from '../../constants';

export default defineComponent({
	props: {
		id: {
			required: true,
			type: String,
		},
	},
	setup(props, { root }) {
		const {
			isLoaded: resourcesAreLoaded,
			hasError: resourcesHaveError,
			samplingCollections: submittedSamplingCollections,
		} = useAllResources(root.$store);

		const {
			isLoaded: draftsAreLoaded,
			hasError: draftsHaveError,
			samplingCollections: draftSamplingCollections,
		} = useAllSamplingCollections(root.$store);

		const { isLoaded: samplingsAreLoaded, hasError: samplingsHaveError } = useAllSamplings(root.$store);

		const isLoaded = computed(() => resourcesAreLoaded.value && draftsAreLoaded.value && samplingsAreLoaded.value);

		const hasError = computed(() =>
			[draftsHaveError.value, samplingsHaveError.value, resourcesHaveError.value].some(Boolean)
		);

		const samplingCollectionStatus: ComputedRef<SamplingCollectionStatus> = computed(() =>
			root.$store.getters.getSamplingCollectionStatusBySamplingCollectionId(props.id)
		);

		const samplingCollection: ComputedRef<SamplingCollection | undefined> = computed(
			() =>
				submittedSamplingCollections.value?.find(({ id }: SamplingCollection) => id === props.id) ||
				draftSamplingCollections.value?.find(({ id }: SamplingCollection) => id === props.id)
		);

		const field: ComputedRef<Field | undefined> = computed(() =>
			root.$store.getters['resources/getFieldById'](samplingCollection.value?.featureOfInterest)
		);

		const samplings: ComputedRef<Sampling[]> = computed(() => {
			if (samplingCollectionStatus.value === 'SUBMITTED') {
				return root.$store.getters['resources/getSamplingsBySamplingCollectionId'](props.id);
			}
			if (samplingCollectionStatus.value === 'DRAFT') {
				return root.$store.getters['samplings/getBySamplingCollectionId'](props.id);
			}
			return [];
		});

		const locationCollection: ComputedRef<LocationCollection | undefined> = computed(() =>
			root.$store.getters['resources/getLocationCollectionById'](samplingCollection.value?.object)
		);

		const locationsCount: ComputedRef<number> = computed(() => locationCollection.value?.features?.length ?? 0);

		const progressText: ComputedRef<string> = computed(() =>
			isLoaded.value
				? locationCollection.value
					? `${samplings.value.length} / ${locationsCount.value}`
					: `${samplings.value.length}`
				: ''
		);

		return {
			samplingCollection,
			field,
			progressText,
			isLoaded,
			hasError,
			locationCollection,
			ORPHANED_DRAFT_SAMPLING_COLLECTION_INFO,
		};
	},
});
</script>

<style></style>
